#! /usr/bin/guile -s
!#

;; Copyright (C) 2001  Neal H Walfield  <neal@cs.uml.edu>
;;
;; This file is part of the Deride
;;
;; Deride is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;; 
;; Deride is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with the GNU Hurd; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(use-modules (irc))

(define (client-display data) (display data))

;; The nick name to use
(define deride-nick "deride")

;; Our `Real Name'
(define deride-real-name "GNU Deride")

;; A list of irc servers and ports on which to attempt to connect to them
;; E.g. '(("server1" . (port1 port2)) ("server2" . (port1 port2 port3)))
(define irc-servers '(("irc.debian.org" . (6667))))

;; The channel to join on startup.
(define irc-channel "#hird")

(define (main)
  (define (try-connect irc-servers)
    (client-display (string-append
		     "Connecting to " (caar irc-servers) ":"))
    (client-display (cadar irc-servers))
    (client-display "... ")
    (or
     (irc-connect (caar irc-servers) (cadar irc-servers))
     (begin
       (client-display "failed.\n")
       (try-connect (if (eqv? (cddar irc-servers) '())
			(cdr irc-servers)
			(cons
			 (cons (caar irc-servers) (cddar irc-servers))
			 (cdr irc-servers)))))))

  (let ((socket (try-connect irc-servers)))
    (if socket
	(begin
	  (irc-send-login socket deride-nick deride-real-name)
	  (irc-send-raw (string-append "JOIN " irc-channel) socket)
	  (irc-loop socket)
 
	  (client-display "Connection closed.\n"))
	(begin
	  (client-display "Failed to connect; sleeping.\n")
	  (sleep 10))))

  (main))

(main)